<?php

class FCKeditorSkin
{
    private $skin;

	function makeImageLinkObj( $nt, $label, $alt, $align = '', $params = array(), $framed = false,
	  $thumb = false, $manual_thumb = '', $valign = '' )
	{
		global $wgContLang, $wgUser, $wgThumbLimits;
		
		$width = (isset($params['width'])) ? " width=\"{$params['width']}\"" : "";
		$height = (isset($params['height'])) ? " height=\"{$params['height']}\"" : "";
		$alt = (!is_null($alt) && strlen($alt)>0) ? "alt=\"$alt\"" : "";
		
		return "<img src=\"{$nt->getFullText()}\"{$width}{$height}{$alt} />";
	}
    
    function makeKnownLinkObj( $nt, $text = '', $query = '', $trail = '', $prefix = '' , $aprops = '', $style = '' )
    {
		$fname = 'FCKeditorSkin::makeKnownLinkObj';
		wfProfileIn( $fname );

		if ( !is_object( $nt ) ) {
			wfProfileOut( $fname );
			return $text;
		}

		//$u = $nt->escapeLocalURL( $query );
		$u = $nt->getFullText();
		
		if ( $nt->getFragment() != '' ) {
			if( $nt->getPrefixedDbkey() == '' ) {
				$u = '';
				if ( '' == $text ) {
					$text = htmlspecialchars( $nt->getFragment() );
				}
			}
			$u .= $nt->getFragmentForURL();
		}
		if ( $text == '' ) {
			$text = htmlspecialchars( $nt->getPrefixedText() );
		}

		list( $inside, $trail ) = Linker::splitTrail( $trail );
		$r = "<a href=\"{$u}\">{$prefix}{$text}{$inside}</a>{$trail}";
		wfProfileOut( $fname );
		return $r;
    }
    
    function makeBrokenLinkObj( $nt, $text = '', $query = '', $trail = '', $prefix = '' )
    {
		# Fail gracefully
		if ( ! isset($nt) ) {
			# throw new MWException();
			return "<!-- ERROR -->{$prefix}{$text}{$trail}";
		}

		$fname = 'FCKeditorSkin::makeBrokenLinkObj';
		wfProfileIn( $fname );

		//$u = $nt->escapeLocalURL( $query );
		//$u = $nt->getText();
		//$u = $nt->getEscapedText();
		$u = $nt->getFullText();
		//print_r($nt);
		
		if ( '' == $text ) {
			$text = htmlspecialchars( $nt->getPrefixedText() );
		}

		list( $inside, $trail ) = Linker::splitTrail( $trail );
		$s = "<a href=\"{$u}\">{$prefix}{$text}{$inside}</a>{$trail}";

		wfProfileOut( $fname );
		return $s;
    }    
    
	function makeExternalLink( $url, $text, $escape = true, $linktype = '', $ns = null ) {		
		$url = htmlspecialchars( $url );
		if( $escape ) {
			$text = htmlspecialchars( $text );
		}
		if ($linktype == 'autonumber') {
		    return '<a href="'.$url.'">[autonumber]</a>';
		}
		return '<a href="'.$url.'">'.$text.'</a>';
	}
    
    function __call( $m, $a)
    {
    	return call_user_func_array( array( $this->skin, $m ), $a );
    }
    
    function __construct( &$skin )
    {
    	$this->skin = $skin;
    }
}
